extern "C" {
    typedef long unsigned int size_t;
    typedef struct
    {
        union
        {
        }
        __value;
    }
    _G_fpos_t;
}
namespace std
{
typedef long int ptrdiff_t;
}
namespace std __attribute__ ((__visibility__ ("default")))
{
template<typename _Tp> struct __is_integer
{
    enum
    {
        __value = 0
    };
};
}
namespace __gnu_cxx __attribute__ ((__visibility__ ("default")))
{
template<bool _Cond, typename _Iftrue, typename _Iffalse> struct __conditional_type
{
    typedef _Iftrue __type;
};
template<typename _Value> struct __numeric_traits_integer
{
    static const _Value __min = (((_Value)(-1) < 0) ? (_Value)1 << (sizeof(_Value) * 8 - ((_Value)(-1) < 0)) : (_Value)0);
    static const _Value __max = (((_Value)(-1) < 0) ? (((((_Value)1 << ((sizeof(_Value) * 8 - ((_Value)(-1) < 0)) - 1)) - 1) << 1) + 1) : ~(_Value)0);
};
template<typename _Value> struct __numeric_traits_floating
{
};
template<typename _Value> struct __numeric_traits : public __conditional_type<std::__is_integer<_Value>::__value, __numeric_traits_integer<_Value>, __numeric_traits_floating<_Value> >::__type
{
};
}
namespace std __attribute__ ((__visibility__ ("default")))
{
template<class _T1, class _T2> struct pair
{
    _T1 first;
    _T2 second;
    pair(const _T1& __a, const _T2& __b) : first(__a), second(__b)
    {
    }
};
template<typename _Tp> inline const _Tp& min(const _Tp& __a, const _Tp& __b)
{
    if (__b < __a) return __b;
    return __a;
}
template<typename _CharT> struct char_traits;
}
namespace __gnu_cxx __attribute__ ((__visibility__ ("default")))
{
using std::ptrdiff_t;
template<typename _Tp> class new_allocator
{
public:
    typedef size_t size_type;
    typedef ptrdiff_t difference_type;
    typedef _Tp* pointer;
    template<typename _Tp1> struct rebind
    {
        typedef new_allocator<_Tp1> other;
    };
};
}
namespace std __attribute__ ((__visibility__ ("default")))
{
template<typename _Tp> class allocator: public __gnu_cxx::new_allocator<_Tp>
{
};
template<typename _CharT, typename _Traits = char_traits<_CharT>, typename _Alloc = allocator<_CharT> > class basic_string;
typedef basic_string<char> string;
template<> struct char_traits<char>
{
    typedef char char_type;
    static int compare(const char_type* __s1, const char_type* __s2, size_t __n)
    {
        return __builtin_memcmp(__s1, __s2, __n);
    }
};
template<typename _Arg, typename _Result> struct unary_function
{
};
template<typename _Arg1, typename _Arg2, typename _Result> struct binary_function
{
};
template<typename _Tp> struct less : public binary_function<_Tp, _Tp, bool>
{
    bool operator()(const _Tp& __x, const _Tp& __y) const
    {
        return __x < __y;
    }
};
template<typename _Pair> struct _Select1st : public unary_function<_Pair, typename _Pair::first_type>
{
};
}
typedef union
{
    struct
    {
    }
    __data;
}
pthread_barrierattr_t;
typedef int _Atomic_word;
namespace __gnu_cxx __attribute__ ((__visibility__ ("default")))
{
static inline _Atomic_word __attribute__ ((__unused__)) __exchange_and_add_dispatch(_Atomic_word* __mem, int __val)
{
}
}
namespace std __attribute__ ((__visibility__ ("default")))
{
template<typename _CharT, typename _Traits, typename _Alloc> class basic_string
{
    typedef typename _Alloc::template rebind<_CharT>::other _CharT_alloc_type;
public:
    typedef _Traits traits_type;
    typedef _Alloc allocator_type;
    typedef typename _CharT_alloc_type::size_type size_type;
    typedef typename _CharT_alloc_type::difference_type difference_type;
private:
    struct _Rep_base
    {
        size_type _M_length;
        _Atomic_word _M_refcount;
    };
    struct _Rep : _Rep_base
    {
        _CharT* _M_refdata() throw()
        {
            return reinterpret_cast<_CharT*>(this + 1);
        }
        void _M_dispose(const _Alloc& __a)
        {
            if (__builtin_expect(this != &_S_empty_rep(), false))
            {
                if (__gnu_cxx::__exchange_and_add_dispatch(&this->_M_refcount, -1) <= 0)
                {
                    _M_destroy(__a);
                }
            }
        }
        void _M_destroy(const _Alloc&) throw();
    };
    struct _Alloc_hider : _Alloc
    {
        _Alloc_hider(_CharT* __dat, const _Alloc& __a) : _Alloc(__a), _M_p(__dat)
        {
        }
        _CharT* _M_p;
    };
private:
    mutable _Alloc_hider _M_dataplus;
    _CharT* _M_data() const
    {
        return _M_dataplus._M_p;
    }
    _Rep* _M_rep() const
    {
        return &((reinterpret_cast<_Rep*> (_M_data()))[-1]);
    }
    static int _S_compare(size_type __n1, size_type __n2)
    {
        const difference_type __d = difference_type(__n1 - __n2);
        if (__d > __gnu_cxx::__numeric_traits<int>::__max) return __gnu_cxx::__numeric_traits<int>::__max;
        else if (__d < __gnu_cxx::__numeric_traits<int>::__min) return __gnu_cxx::__numeric_traits<int>::__min;
    }
    static _Rep& _S_empty_rep()
    {
    }
public:
    basic_string() : _M_dataplus(_S_empty_rep()._M_refdata(), _Alloc())
    {
    }
    basic_string(const basic_string& __str);
    basic_string(const _CharT* __s, const _Alloc& __a = _Alloc());
    ~basic_string()
    {
        _M_rep()->_M_dispose(this->get_allocator());
    }
public:
    size_type size() const
    {
        return _M_rep()->_M_length;
    }
    const _CharT* data() const
    {
    }
    allocator_type get_allocator() const
    {
    }
    int compare(const basic_string& __str) const
    {
        const size_type __size = this->size();
        const size_type __osize = __str.size();
        const size_type __len = std::min(__size, __osize);
        int __r = traits_type::compare(_M_data(), __str.data(), __len);
        if (!__r) __r = _S_compare(__size, __osize);
        return __r;
    }
};
template<typename _CharT, typename _Traits, typename _Alloc> inline bool operator<(const basic_string<_CharT, _Traits, _Alloc>& __lhs, const basic_string<_CharT, _Traits, _Alloc>& __rhs)
{
    return __lhs.compare(__rhs) < 0;
}
struct _Rb_tree_node_base
{
    typedef _Rb_tree_node_base* _Base_ptr;
    typedef const _Rb_tree_node_base* _Const_Base_ptr;
    _Base_ptr _M_parent;
    _Base_ptr _M_left;
    _Base_ptr _M_right;
};
template<typename _Val> struct _Rb_tree_node : public _Rb_tree_node_base
{
    _Val _M_value_field;
};
template<typename _Tp> struct _Rb_tree_iterator
{
    typedef _Tp& reference;
    typedef _Rb_tree_iterator<_Tp> _Self;
    typedef _Rb_tree_node_base::_Base_ptr _Base_ptr;
    typedef _Rb_tree_node<_Tp>* _Link_type;
    explicit _Rb_tree_iterator(_Link_type __x) : _M_node(__x)
    {
    }
    reference operator*() const
    {
        return static_cast<_Link_type>(_M_node)->_M_value_field;
    }
    bool operator==(const _Self& __x) const
    {
    }
    _Base_ptr _M_node;
};
template<typename _Tp> struct _Rb_tree_const_iterator
{
    typedef _Rb_tree_iterator<_Tp> iterator;
    typedef _Rb_tree_node_base::_Const_Base_ptr _Base_ptr;
    _Rb_tree_const_iterator(const iterator& __it) : _M_node(__it._M_node)
    {
    }
    _Base_ptr _M_node;
};
template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc = allocator<_Val> > class _Rb_tree
{
    typedef typename _Alloc::template rebind<_Rb_tree_node<_Val> >::other _Node_allocator;
protected:
    typedef _Rb_tree_node_base* _Base_ptr;
    typedef const _Rb_tree_node_base* _Const_Base_ptr;
public:
    typedef _Key key_type;
    typedef _Val value_type;
    typedef _Rb_tree_node<_Val>* _Link_type;
    typedef size_t size_type;
protected:
    template<typename _Key_compare, bool _Is_pod_comparator = __is_pod(_Key_compare)> struct _Rb_tree_impl : public _Node_allocator
    {
        _Key_compare _M_key_compare;
        _Rb_tree_node_base _M_header;
        size_type _M_node_count;
        _Rb_tree_impl() : _Node_allocator(), _M_key_compare(), _M_header(), _M_node_count(0)
        {
        }
    };
    _Rb_tree_impl<_Compare> _M_impl;
    _Link_type _M_begin()
    {
        return static_cast<_Link_type>(this->_M_impl._M_header._M_parent);
    }
    _Link_type _M_end()
    {
        return static_cast<_Link_type>(&this->_M_impl._M_header);
    }
    static _Link_type _S_left(_Base_ptr __x)
    {
    }
    static _Link_type _S_right(_Base_ptr __x)
    {
    }
    static const _Key& _S_key(_Const_Base_ptr __x)
    {
    }
public:
    typedef _Rb_tree_iterator<value_type> iterator;
    typedef _Rb_tree_const_iterator<value_type> const_iterator;
    iterator _M_lower_bound(_Link_type __x, _Link_type __y, const _Key& __k);
    iterator end()
    {
    }
    iterator _M_insert_unique_(const_iterator __position, const value_type& __x);
    iterator find(const key_type& __k);
    iterator lower_bound(const key_type& __k)
    {
        return _M_lower_bound(_M_begin(), _M_end(), __k);
    }
};
template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc> typename _Rb_tree<_Key, _Val, _KeyOfValue, _Compare, _Alloc>::iterator _Rb_tree<_Key, _Val, _KeyOfValue, _Compare, _Alloc>:: _M_lower_bound(_Link_type __x, _Link_type __y, const _Key& __k)
{
    while (__x != 0) if (!_M_impl._M_key_compare(_S_key(__x), __k)) __y = __x, __x = _S_left(__x);
        else __x = _S_right(__x);
    return iterator(__y);
}
template<typename _Key, typename _Val, typename _KeyOfValue, typename _Compare, typename _Alloc> typename _Rb_tree<_Key, _Val, _KeyOfValue, _Compare, _Alloc>::iterator _Rb_tree<_Key, _Val, _KeyOfValue, _Compare, _Alloc>:: find(const _Key& __k)
{
    iterator __j = _M_lower_bound(_M_begin(), _M_end(), __k);
    return (__j == end() || _M_impl._M_key_compare(__k, _S_key(__j._M_node))) ? end() : __j;
}
template <typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<std::pair<const _Key, _Tp> > > class map
{
public:
    typedef _Key key_type;
    typedef _Tp mapped_type;
    typedef std::pair<const _Key, _Tp> value_type;
    typedef _Compare key_compare;
private:
    typedef typename _Alloc::template rebind<value_type>::other _Pair_alloc_type;
    typedef _Rb_tree<key_type, value_type, _Select1st<value_type>, key_compare, _Pair_alloc_type> _Rep_type;
    _Rep_type _M_t;
public:
    typedef typename _Pair_alloc_type::pointer pointer;
    typedef typename _Rep_type::iterator iterator;
    iterator end()
    {
    }
    mapped_type& operator[](const key_type& __k)
    {
        iterator __i = lower_bound(__k);
        if (__i == end() || key_comp()(__k, (*__i).first)) __i = insert(__i, value_type(__k, mapped_type()));
    }
    iterator insert(iterator __position, const value_type& __x)
    {
        return _M_t._M_insert_unique_(__position, __x);
    }
    key_compare key_comp() const
    {
    }
    iterator find(const key_type& __x)
    {
        return _M_t.find(__x);
    }
    iterator lower_bound(const key_type& __x)
    {
        return _M_t.lower_bound(__x);
    }
};
}
void *compile_pattern(const char *pattern, bool ignore_case = false);
void free_compiled_pattern(void *cp);
bool pattern_match(void *compiled_pattern, const char *text, int length);
typedef void *(*p_compile)(const char *pattern, bool ignore_case);
typedef void (*p_free)(void *cp);
typedef bool (*p_match)(void *compiled_pattern, const char *text, int length);
class base_pattern
{
};
template <p_compile pcomp, p_free pfree, p_match pmatch> class basic_text_pattern : public base_pattern
{
public:
    basic_text_pattern(const std::string &s, bool icase = false) : pattern(s), compiled_pattern(__null), isvalid(true), ignore_case(icase)
    {
    }
    basic_text_pattern() : pattern(), compiled_pattern(__null), isvalid(false), ignore_case(false)
    {
    }
private:
    std::string pattern;
    mutable void *compiled_pattern;
    mutable bool isvalid;
    bool ignore_case;
};
typedef basic_text_pattern<compile_pattern, free_compiled_pattern, pattern_match> text_pattern;
extern "C" {
    typedef struct lua_State lua_State;
    typedef int (*lua_CFunction) (lua_State *L);
    extern "C" void (lua_pushcclosure) (lua_State *L, lua_CFunction fn, int n);
    extern "C" const char *(luaL_checklstring) (lua_State *L, int numArg, size_t *l);
}
typedef std::map<std::string, text_pattern> pattern_map;
static pattern_map pattern_cache;
static text_pattern &get_text_pattern(const std::string &s, bool checkcase)
{
    pattern_map::iterator i = pattern_cache.find(s);
    pattern_cache[s] = text_pattern(s, !checkcase);
    return (pattern_cache[s]);
}
static int lua_pmatch(lua_State *ls)
{
    const char *pattern = (luaL_checklstring(ls, (1), __null));
    bool checkcase = true;
    text_pattern &tp = get_text_pattern(pattern, checkcase);
}
void cluaopen_globals(lua_State *ls)
{
    lua_pushcclosure(ls, (lua_pmatch), 0);
}
